/**
* DevExtreme (renovation/ui/scheduler/appointment_tooltip/types.d.ts)
* Version: 21.1.3 (build 21154-1903)
* Build date: Thu Jun 03 2021
*
* Copyright (c) 2012 - 2021 Developer Express Inc. ALL RIGHTS RESERVED
* Read about DevExtreme licensing here: https://js.devexpress.com/Licensing/
*/
// https://github.com/benmosher/eslint-plugin-import/issues/1699
// eslint-disable-next-line import/named
import { dxSchedulerAppointment } from '../../../../ui/scheduler';

/**
 * @deprecated Warning! This type is used for internal purposes. Do not import it directly.
 */
export type Color = string | undefined;

/**
 * @deprecated Warning! This type is used for internal purposes. Do not import it directly.
 */
export interface AppointmentItem {
  data: dxSchedulerAppointment;
  currentData?: dxSchedulerAppointment;
  settings?: AppointmentItemSettings;
  color?: Promise<Color>;
  disabled?: boolean;
}

/**
 * @deprecated Warning! This type is used for internal purposes. Do not import it directly.
 */
export interface AppointmentItemSettings {
  targetedAppointmentData?: dxSchedulerAppointment;
  originalAppointmentStartDate?: Date;
  originalAppointmentEndDate?: Date;
  startDate?: Date;
  endDate?: Date;
  direction?: 'vertical' | 'horizontal';
  allDay?: boolean;
  isCompact?: boolean;
  virtual?: boolean;
  groupIndex?: number;
  appointmentReduced?: boolean;
  sortedIndex?: number;
}

/**
 * @deprecated Warning! This type is used for internal purposes. Do not import it directly.
 */
export interface FormattedContent {
  text: string;
  formatDate: string;
}

/**
 * @deprecated Warning! This type is used for internal purposes. Do not import it directly.
 */
export type GetTextAndFormatDateFn = (
  appointment?: dxSchedulerAppointment, currentAppointment?: dxSchedulerAppointment,
) => FormattedContent;

/**
 * @deprecated Warning! This type is used for internal purposes. Do not import it directly.
 */
export type GetSingleAppointmentFn = (
  appointment: dxSchedulerAppointment, target?: HTMLElement,
) => dxSchedulerAppointment;

/**
 * @deprecated Warning! This type is used for internal purposes. Do not import it directly.
 */
export type CheckAndDeleteAppointmentFn = (
  appointment: dxSchedulerAppointment, currentAppointment: dxSchedulerAppointment,
) => void;

/**
 * @deprecated Warning! This type is used for internal purposes. Do not import it directly.
 */
export type ShowAppointmentPopupFn = (
  appointment: dxSchedulerAppointment, visibleButtons: boolean,
  currentAppointment: dxSchedulerAppointment,
) => void;

/**
 * @deprecated Warning! This type is used for internal purposes. Do not import it directly.
 */
export interface AppointmentTooltipTemplate {
  model: {
    appointmentData: dxSchedulerAppointment;
    targetedAppointmentData: dxSchedulerAppointment;
  };
  index: number;
}
