/**
* DevExtreme (renovation/viz/common/types.d.ts)
* Version: 21.1.3 (build 21154-1903)
* Build date: Thu Jun 03 2021
*
* Copyright (c) 2012 - 2021 Developer Express Inc. ALL RIGHTS RESERVED
* Read about DevExtreme licensing here: https://js.devexpress.com/Licensing/
*/
/**
 * @deprecated Warning! This type is used for internal purposes. Do not import it directly.
 */
type FormatType = 'billions' | 'currency' | 'day' | 'decimal' | 'exponential' | 'fixedPoint' | 'largeNumber' | 'longDate' | 'longTime' | 'millions' | 'millisecond' | 'month' | 'monthAndDay' | 'monthAndYear' | 'percent' | 'quarter' | 'quarterAndYear' | 'shortDate' | 'shortTime' | 'thousands' | 'trillions' | 'year' | 'dayOfWeek' | 'hour' | 'longDateLongTime' | 'minute' | 'second' | 'shortDateShortTime';
/**
 * @deprecated Warning! This type is used for internal purposes. Do not import it directly.
 */
export interface FormatObject {
  type?: FormatType;
  precision?: number;
  currency?: string;
  percentPrecision?: number;
}
/**
 * @deprecated Warning! This type is used for internal purposes. Do not import it directly.
 */
export type Format = FormatObject | FormatType | string | ((value: number | Date) => string);
/**
 * @deprecated Warning! This type is used for internal purposes. Do not import it directly.
 */
export interface Point {
  size: number;
  tag: any;
  originalArgument: Date | string | number;
  originalValue: Date | string | number;
}

/**
 * @deprecated Warning! This type is used for internal purposes. Do not import it directly.
 */
export interface Translator {
  translate: (value: number | string | Date) => number;
}

/**
 * @deprecated Warning! This type is used for internal purposes. Do not import it directly.
 */
export interface BaseEventData {
  readonly component: any; // TODO: after improve refs use ref of the widget
}

/**
 * @deprecated Warning! This type is used for internal purposes. Do not import it directly.
 */
export interface EventData<T> extends BaseEventData {
  readonly target?: T;
}

/**
 * @deprecated Warning! This type is used for internal purposes. Do not import it directly.
 */
export type OnTooltipShownFn<T> = (e: T) => void;
/**
 * @deprecated Warning! This type is used for internal purposes. Do not import it directly.
 */
export type OnTooltipHiddenFn<T> = (e: T) => void;

/**
 * @deprecated Warning! This type is used for internal purposes. Do not import it directly.
 */
export interface Size { width?: number; height?: number }
/**
 * @deprecated Warning! This type is used for internal purposes. Do not import it directly.
 */
export interface RecalculateCoordinates {
  canvas: ClientRect; anchorX: number; anchorY: number;
  size: Required<Size>; offset: number; arrowLength: number;
}
/**
 * @deprecated Warning! This type is used for internal purposes. Do not import it directly.
 */
export interface TooltipCoordinates { x: number; y: number; anchorX: number; anchorY: number }
/**
 * @deprecated Warning! This type is used for internal purposes. Do not import it directly.
 */
export interface Margin { top?: number; left?: number; bottom?: number; right?: number }
/**
 * @deprecated Warning! This type is used for internal purposes. Do not import it directly.
 */
export interface InitialBorder {
  color: string; width: number; dashStyle: string; opacity?: number; visible: boolean;
}
/**
 * @deprecated Warning! This type is used for internal purposes. Do not import it directly.
 */
export interface Border {
  stroke?: string; strokeWidth?: number; strokeOpacity?: number; dashStyle?: string;
}
/**
 * @deprecated Warning! This type is used for internal purposes. Do not import it directly.
 */
export interface CustomizedOptions {
  text?: string | null;
  html?: string | null;
  color?: string;
  borderColor?: string;
  fontColor?: string;
}
/**
 * @deprecated Warning! This type is used for internal purposes. Do not import it directly.
 */
export type CustomizeTooltipFn = (info: any) => CustomizedOptions;
/**
 * @deprecated Warning! This type is used for internal purposes. Do not import it directly.
 */
export type Location = 'center' | 'edge';
/**
 * @deprecated Warning! This type is used for internal purposes. Do not import it directly.
 */
export type Container = string | HTMLElement;
/**
 * @deprecated Warning! This type is used for internal purposes. Do not import it directly.
 */
export interface TooltipData {
  value?: number | Date | string;
  argument?: number | Date | string;
  valueText?: string;
  argumentText?: string;
  originalValue?: number | Date | string;
  originalArgument?: number | Date | string;
  seriesName?: string;
  description?: string;
}
/**
 * @deprecated Warning! This type is used for internal purposes. Do not import it directly.
 */
export interface Font {
  color?: string;
  family?: string;
  opacity?: number;
  size?: number;
  weight?: number;
  lineSpacing?: number;
}
