/**
* DevExtreme (ui/nav_bar.d.ts)
* Version: 21.1.3 (build 21154-1903)
* Build date: Thu Jun 03 2021
*
* Copyright (c) 2012 - 2021 Developer Express Inc. ALL RIGHTS RESERVED
* Read about DevExtreme licensing here: https://js.devexpress.com/Licensing/
*/
import {
    UserDefinedElement
} from '../core/element';

import {
    EventInfo,
    NativeEventInfo,
    InitializedEventInfo,
    ChangedOptionInfo,
    ItemInfo
} from '../events/index';

import {
    SelectionChangedInfo
} from './collection/ui.collection_widget.base';

import dxTabs, {
    dxTabsItem,
    dxTabsOptions
} from './tabs';

export type ContentReadyEvent = EventInfo<dxNavBar>;

export type DisposingEvent = EventInfo<dxNavBar>;

export type InitializedEvent = InitializedEventInfo<dxNavBar>;

export type ItemClickEvent = NativeEventInfo<dxNavBar> & ItemInfo;

export type ItemContextMenuEvent = NativeEventInfo<dxNavBar> & ItemInfo;

export type ItemHoldEvent = NativeEventInfo<dxNavBar> & ItemInfo;

export type ItemRenderedEvent = NativeEventInfo<dxNavBar> & ItemInfo;

export type OptionChangedEvent = EventInfo<dxNavBar> & ChangedOptionInfo;

export type SelectionChangedEvent = EventInfo<dxNavBar> & SelectionChangedInfo;

/**
 * @deprecated use Properties instead
 * @deprecated Warning! This type is used for internal purposes. Do not import it directly.
 */
export interface dxNavBarOptions extends dxTabsOptions<dxNavBar> {
    /**
     * 
     */
    scrollByContent?: boolean;
}
/**
 * The NavBar is a UI component that navigates the application views.
 */
export default class dxNavBar extends dxTabs {
    constructor(element: UserDefinedElement, options?: dxNavBarOptions)
}

/**
 * 
 * @deprecated Warning! This type is used for internal purposes. Do not import it directly.
 */
export interface dxNavBarItem extends dxTabsItem {
    /**
     * Specifies a badge text for the navbar item.
     */
    badge?: string;
}

export type Properties = dxNavBarOptions;

/**
 * @deprecated use Properties instead
 * @deprecated Warning! This type is used for internal purposes. Do not import it directly.
 */
export type Options = dxNavBarOptions;

/**
 * @deprecated use Properties instead
 * @deprecated Warning! This type is used for internal purposes. Do not import it directly.
 */
export type IOptions = dxNavBarOptions;
